/*
This file is part of FSDB: a higher level library to access a Firebird database using IBPP.

Copyright Fulvio Senore.

License:

Permission is hereby granted, free of charge, to any person or organization ("You") obtaining a copy of this software and 
associated documentation files covered by this license (the "Software") to use the Software as part of another work; 
to modify it for that purpose; to publish or distribute it, modified or not, for that same purpose; 
to permit persons to whom the other work using the Software is furnished to do so; subject to the following conditions: 
the above copyright notice and this complete and unmodified permission notice shall be included in all copies or substantial 
portions of the Software; You will not misrepresent modified versions of the Software as being the original.

The Software is provided "as is", without warranty of any kind, express or implied, including but not limited 
to the warranties of merchantability, fitness for a particular purpose and noninfringement. 
In no event shall the authors or copyright holders be liable for any claim, damages or other liability, 
whether in an action of contract, tort or otherwise, arising from, out of or in connection with the software 
or the use of other dealings in the Software.
*/


#ifndef __FSDB_RECORDSET_RFO_RO_H__
#define __FSDB_RECORDSET_RFO_RO_H__

#include "recordset_fo_ro.h"

namespace FSDB {

	/// A forward-only, read-only recordset where it is possible to move back to the first row.
	/// The recordset opens a "repeatable reads" query and moves back to the first row by repeating the query
	class Recordset_RFO_RO : public Recordset_FO_RO {

	public:

		Recordset_RFO_RO( RecordsetType rt, DbInterfaceBase *DbInterface ) : Recordset_FO_RO( rt, DbInterface ) {}
		~Recordset_RFO_RO() {}
		
		/// return to the first row
		void MoveFirst();
	};

}

#endif

