/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        choose_virtual_folder.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     07/03/2009 08:49:00
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _CHOOSE_VIRTUAL_FOLDER_H_
#define _CHOOSE_VIRTUAL_FOLDER_H_


/*!
 * Includes
 */

#include "window_position.h"

////@begin includes
#include "wx/treectrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class CTreeCtrlVirtual;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_DIALOG_CHOOSE_VIRTUAL_FOLDER 10066
#define ID_CHOICE_RECENT 10125
#define ID_COMBO_RECENT 10133
#define ID_TREECTRL 10067
#define SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_TITLE _("Choose virtual folder")
#define SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_IDNAME ID_DIALOG_CHOOSE_VIRTUAL_FOLDER
#define SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_SIZE wxSize(400, 300)
#define SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CDialogChooseVirtualFolder class declaration
 */

class CDialogChooseVirtualFolder: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CDialogChooseVirtualFolder )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CDialogChooseVirtualFolder();
    CDialogChooseVirtualFolder( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_IDNAME, const wxString& caption = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_TITLE, const wxPoint& pos = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_POSITION, const wxSize& size = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_SIZE, long style = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_IDNAME, const wxString& caption = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_TITLE, const wxPoint& pos = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_POSITION, const wxSize& size = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_SIZE, long style = SYMBOL_CDIALOGCHOOSEVIRTUALFOLDER_STYLE );

    /// Destructor
    ~CDialogChooseVirtualFolder();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CDialogChooseVirtualFolder event handler declarations

#if defined(__WXMSW__) || defined(__WXMAC__)
    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_CHOICE_RECENT
    void OnChoiceRecentSelected( wxCommandEvent& event );

#endif
#if defined(__WXGTK__)
    /// wxEVT_COMMAND_COMBOBOX_SELECTED event handler for ID_COMBO_RECENT
    void OnChoiceRecentSelected( wxCommandEvent& event );

#endif
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_OK
    void OnOkClick( wxCommandEvent& event );

////@end CDialogChooseVirtualFolder event handler declarations

////@begin CDialogChooseVirtualFolder member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CDialogChooseVirtualFolder member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CDialogChooseVirtualFolder member variables
#if defined(__WXMSW__) || defined(__WXMAC__)
    wxChoice* m_RecentFoldersCtrl;
#endif
#if defined(__WXGTK__)
    wxComboBox* m_RecentFoldersCtrl;
#endif
    CTreeCtrlVirtual* m_TreeCtrlVirtual;
////@end CDialogChooseVirtualFolder member variables

	int GetVirtualFolderID() { return m_VirtualFolderID; }

	// fills a wxArrayString with the name of the current folder and all its parents
	void GetCurrentPathArray( wxArrayString& as );

	// selects the folder saved in the array. The array has been previously filled by GetCurrentPathArray()
	void SetCurrentPathArray( wxArrayString& as );

private:

	int m_VirtualFolderID;		// primary key of the choosen virtual foder

	CWindowPosition m_WindowPosition;

};

#endif
    // _CHOOSE_VIRTUAL_FOLDER_H_
