/////////////////////////////////////////////////////////////////////////////
// Name:        copy_files_to_location_dialog.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     26/06/2009 11:08:43
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _COPY_FILES_TO_LOCATION_DIALOG_H_
#define _COPY_FILES_TO_LOCATION_DIALOG_H_


/*!
 * Includes
 */

////@begin includes
////@end includes

#include "window_position.h"

#include <vector>

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CCOPYFILESTOLOCATIONDIALOG 10083
#define ID_DESTINATION_PATH 10084
#define ID_DESTINATION_PATH_BROWSE 10085
#define ID_CHK_EXTRACT_PREVIEW 10139
#define ID_GAUGE 10086
#define ID_CMD_COPY_FILES 10088
#define SYMBOL_CCOPYFILESTOLOCATIONDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CCOPYFILESTOLOCATIONDIALOG_TITLE _("Copy files to a new location")
#define SYMBOL_CCOPYFILESTOLOCATIONDIALOG_IDNAME ID_CCOPYFILESTOLOCATIONDIALOG
#define SYMBOL_CCOPYFILESTOLOCATIONDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_CCOPYFILESTOLOCATIONDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CCopyFilesToLocationDialog class declaration
 */

class CCopyFilesToLocationDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CCopyFilesToLocationDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CCopyFilesToLocationDialog();
    CCopyFilesToLocationDialog( wxWindow* parent, wxWindowID id = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_IDNAME, const wxString& caption = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_POSITION, const wxSize& size = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_SIZE, long style = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_IDNAME, const wxString& caption = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_TITLE, const wxPoint& pos = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_POSITION, const wxSize& size = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_SIZE, long style = SYMBOL_CCOPYFILESTOLOCATIONDIALOG_STYLE );

    /// Destructor
    ~CCopyFilesToLocationDialog();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CCopyFilesToLocationDialog event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_DESTINATION_PATH_BROWSE
    void OnDestinationPathBrowseClick( wxCommandEvent& event );

#if defined(__WXMSW__)
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CMD_COPY_FILES
    void OnCmdCopyFilesClick( wxCommandEvent& event );

#endif
#if defined(__WXMSW__)
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
    void OnHelpClick( wxCommandEvent& event );

#endif
#if defined(__WXMAC__) || defined(__WXGTK__)
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
    void OnHelpClick( wxCommandEvent& event );

#endif
#if defined(__WXMAC__) || defined(__WXGTK__)
    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_CMD_COPY_FILES
    void OnCmdCopyFilesClick( wxCommandEvent& event );

#endif
////@end CCopyFilesToLocationDialog event handler declarations

////@begin CCopyFilesToLocationDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CCopyFilesToLocationDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

	// set data about the files to copy
	void SetFilesData( std::vector<int> &fileIDs, std::vector<wxString> &fileNames );

	// get the path selected by the user
	wxString GetPath() const;

	// set the copy destination path
	void SetPath( const wxString &path );

	// get the "extract jpeg from RAW" checkbox setting
	bool GetExtractJPEGPrevewFromRAW() const;

	// set the "extract jpeg from RAW" checkbox setting
	void SetExtractJPEGPrevewFromRAW( const bool setting );

////@begin CCopyFilesToLocationDialog member variables
    wxStaticText* m_NFilesCtrl;
    wxTextCtrl* m_DestinationPathCtrl;
    wxButton* m_BrowseCtrl;
    wxCheckBox* m_ExtractPreviewCtrl;
    wxGauge* m_ProgressBarCtrl;
////@end CCopyFilesToLocationDialog member variables

private:

	CWindowPosition m_WindowPosition;

	std::vector<int> fileIDs;
	std::vector<wxString> fileNames;
};

#endif
    // _COPY_FILES_TO_LOCATION_DIALOG_H_
