/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "db_sequences.h"
#include "vvvpapp.h"

#include "fsdb.h"

using namespace FSDB;


CDbSequences::CDbSequences(void)
{
}

CDbSequences::~CDbSequences(void)
{
}

long CDbSequences::GetNextPK( std::string sequenceName ) {
	long retVal;

	Database db = wxGetApp().GetDatabase();
	FSDB_CREATE_RS_READONLY_FWDONLY( db, rs );
	std::string sql = "SELECT GEN_ID(" + sequenceName + ", 1) AS NEW_ID FROM RDB$DATABASE";
	rs.Open( sql );
	retVal = rs["NEW_ID"].GetAsLargeInt();
	rs.Close();

	return retVal;
}

long CDbSequences::GetNextVolumesPK() {
	return GetNextPK( "GEN_VOLUMES_ID" );
}

long CDbSequences::GetNextPathsPK() {
	return GetNextPK( "GEN_PATHS_ID" );
}

long CDbSequences::GetNextFilesPK() {
	return GetNextPK( "GEN_FILES_ID" );
}


long CDbSequences::GetNextMetadataPK() {
	return GetNextPK( "GEN_METADATA_ID" );
}

