/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2008, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// this class incapsulates access to database sequences, used to obtain a primary key for INSERTs
// this changes with the database so it is better to have all the code in the same place

#ifndef __DB_SEQUENCES_H__
#define __DB_SEQUENCES_H__

#include <string>

class CDbSequences
{
public:
	CDbSequences(void);
	~CDbSequences(void);

	static long GetNextVolumesPK();
	static long GetNextPathsPK();
	static long GetNextFilesPK();
	static long GetNextMetadataPK();

private:

	static long GetNextPK( std::string sequenceName );

};



#endif

