/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2009, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// database related useful routines

#ifndef __DB_UTILS_H__
#define __DB_UTILS_H__

#include <wx/string.h>

class CDbUtils
{
public:

	// possible result status when dealing with fixed or removable locations
	enum LocationsStatus {
		lsOk = 0,
		lsMissingFixedLocation = 1,	/* fixed location not defined for this file */
		lsUndefinedFixedLocation = 2	/* fixed location name not defined in this computer */
	};


	// return the full path to the fixed location of a file given its file id and file name (w/out path)
	static LocationsStatus FixedLocationPathFromID( const int fileID, const wxString &fileName, wxString &fullPath );

	// return the full path to the fixed location of a path given the id of one of its files
	static LocationsStatus FixedLocationFolderFromID( const int fileID, wxString &folderPath );

	// return the full path to the fixed location of a path given the path ID
	static LocationsStatus FixedLocationFolderFromPathID( const int pathID, wxString &folderPath );
};


#endif
