/////////////////////////////////////////////////////////////////////////////
// Name:        fs_imagjpeg.h
// Purpose:     wxImage JPEG handler
// Author:      Vaclav Slavik
// RCS-ID:      $Id: imagjpeg.h 37393 2006-02-08 21:47:09Z VZ $
// Copyright:   (c) Vaclav Slavik
// Licence:     wxWindows licence
/////////////////////////////////////////////////////////////////////////////

/*
This is a modified version of the wxJPEGHandler that handles ICC color profiles
*/

#ifndef _FS_IMAGJPEG_H_
#define _FS_IMAGJPEG_H_

#include "wx/defs.h"

//-----------------------------------------------------------------------------
// fsJPEGHandler
//-----------------------------------------------------------------------------

#if wxUSE_LIBJPEG

#include "fs_image.h"

class WXDLLEXPORT fsJPEGHandler: public wxImageHandler
{
public:
    inline fsJPEGHandler()
    {
        m_name = wxT("JPEG file");
        m_extension = wxT("jpg");
        m_type = wxBITMAP_TYPE_JPEG;
        m_mime = wxT("image/jpeg");
    }

#if wxUSE_STREAMS
    virtual bool LoadFile( wxImage *image, wxInputStream& stream, bool verbose=true, int index=-1 );
    virtual bool SaveFile( wxImage *image, wxOutputStream& stream, bool verbose=true );
protected:
    virtual bool DoCanRead( wxInputStream& stream );
#endif

private:
    DECLARE_DYNAMIC_CLASS(fsJPEGHandler)
};

#endif // wxUSE_LIBJPEG

#endif // _FS_IMAGJPEG_H_

