/////////////////////////////////////////////////////////////////////////////
// Name:        long_text_question.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     03/01/2009 15:29:57
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "long_text_question.h"
#include "vvvpapp.h"

////@begin XPM images
////@end XPM images


/*!
 * CLongTextQuestion type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CLongTextQuestion, wxDialog )


/*!
 * CLongTextQuestion event table definition
 */

BEGIN_EVENT_TABLE( CLongTextQuestion, wxDialog )

////@begin CLongTextQuestion event table entries
    EVT_BUTTON( wxID_HELP, CLongTextQuestion::OnHelpClick )
    EVT_UPDATE_UI( wxID_HELP, CLongTextQuestion::OnHelpUpdate )

    EVT_BUTTON( wxID_YES, CLongTextQuestion::OnYesClick )

    EVT_BUTTON( wxID_NO, CLongTextQuestion::OnNoClick )

////@end CLongTextQuestion event table entries

END_EVENT_TABLE()


/*!
 * CLongTextQuestion constructors
 */

CLongTextQuestion::CLongTextQuestion()
{
    Init();
}

CLongTextQuestion::CLongTextQuestion( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * CLongTextQuestion creator
 */

bool CLongTextQuestion::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin CLongTextQuestion creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
    Centre();
////@end CLongTextQuestion creation
    return true;
}


/*!
 * CLongTextQuestion destructor
 */

CLongTextQuestion::~CLongTextQuestion()
{
////@begin CLongTextQuestion destruction
////@end CLongTextQuestion destruction
}


/*!
 * Member initialisation
 */

void CLongTextQuestion::Init()
{
////@begin CLongTextQuestion member initialisation
    m_MainSizer = NULL;
    m_UpperTextCtrl = NULL;
    m_MidTextCtrl = NULL;
    m_LowerTextCtrl = NULL;
////@end CLongTextQuestion member initialisation
}


/*!
 * Control creation for CLongTextQuestion
 */

void CLongTextQuestion::CreateControls()
{    
////@begin CLongTextQuestion content construction
    CLongTextQuestion* itemDialog1 = this;

    m_MainSizer = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(m_MainSizer);

    m_UpperTextCtrl = new wxStaticText( itemDialog1, wxID_STATIC, _("Upper part"), wxDefaultPosition, wxDefaultSize, 0 );
    m_MainSizer->Add(m_UpperTextCtrl, 0, wxGROW|wxALL, 5);

    m_MidTextCtrl = new wxTextCtrl( itemDialog1, ID_CENTRAL_TEXT, wxEmptyString, wxDefaultPosition, wxSize(300, 200), wxTE_MULTILINE|wxTE_READONLY|wxTE_RICH|wxHSCROLL );
    m_MainSizer->Add(m_MidTextCtrl, 1, wxGROW|wxALL, 5);

    m_LowerTextCtrl = new wxStaticText( itemDialog1, wxID_STATIC, _("Lower part"), wxDefaultPosition, wxDefaultSize, 0 );
    m_MainSizer->Add(m_LowerTextCtrl, 0, wxGROW|wxALL, 5);

    wxStdDialogButtonSizer* itemStdDialogButtonSizer6 = new wxStdDialogButtonSizer;

    m_MainSizer->Add(itemStdDialogButtonSizer6, 0, wxGROW|wxALL, 10);
    wxButton* itemButton7 = new wxButton( itemDialog1, wxID_HELP, _("&Help"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer6->AddButton(itemButton7);

    wxButton* itemButton8 = new wxButton( itemDialog1, wxID_YES, _("&Yes"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer6->AddButton(itemButton8);

    wxButton* itemButton9 = new wxButton( itemDialog1, wxID_NO, _("&No"), wxDefaultPosition, wxDefaultSize, 0 );
    itemStdDialogButtonSizer6->AddButton(itemButton9);

    itemStdDialogButtonSizer6->Realize();

////@end CLongTextQuestion content construction
}


/*!
 * Should we show tooltips?
 */

bool CLongTextQuestion::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CLongTextQuestion::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CLongTextQuestion bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CLongTextQuestion bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CLongTextQuestion::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CLongTextQuestion icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CLongTextQuestion icon retrieval
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
 */

void CLongTextQuestion::OnHelpClick( wxCommandEvent& event )
{
	wxGetApp().GetHelpController()->DisplaySection( m_HelpPage );
}

/*!
 * wxEVT_UPDATE_UI event handler for wxID_HELP
 */

void CLongTextQuestion::OnHelpUpdate( wxUpdateUIEvent& event )
{
	event.Enable( !m_HelpPage.empty() );
}

void CLongTextQuestion::AdaptSize() {
	m_MainSizer->Layout();
	m_MainSizer->Fit(this);
	Centre();
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_YES
 */

void CLongTextQuestion::OnYesClick( wxCommandEvent& event )
{
	EndModal( wxID_YES );
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_NO
 */

void CLongTextQuestion::OnNoClick( wxCommandEvent& event )
{
	EndModal( wxID_NO );
}

