
#include "memory_chunk.h"

#include <memory.h>

CMemoryChunk::CMemoryChunk() : m_Buffer(NULL), m_BufferSize(0)
{
}

CMemoryChunk::CMemoryChunk( const void *buf, const size_t bufSize ) : m_Buffer(NULL), m_BufferSize(0)
{
	SetData( buf, bufSize );
}

CMemoryChunk::~CMemoryChunk()
{
	ReleaseMemory();
}

CMemoryChunk::CMemoryChunk( const CMemoryChunk &mc )
{
	Copy( mc );
}

void CMemoryChunk::operator=(const CMemoryChunk& mc)
{
	Copy( mc );
}

void CMemoryChunk::SetData( const void *buf, const size_t bufSize )
{
	ReleaseMemory();
	if( bufSize > 0 ) {
		m_Buffer = new unsigned char[bufSize];
		memcpy( m_Buffer, buf, bufSize );
	}
	m_BufferSize = bufSize;
}

void CMemoryChunk::Copy( const CMemoryChunk &mc )
{
	SetData( mc.m_Buffer, mc.m_BufferSize );
}

void CMemoryChunk::ReleaseMemory()
{
	if( m_Buffer != NULL ) {
		delete m_Buffer;
		m_Buffer = NULL;
	}
	m_BufferSize = 0;
}



