#ifndef __MEMORY_CHUNK_H__
#define __MEMORY_CHUNK_H__

/*
This is a class that helps handling memory chunks.
A memory chunk is defined by its address and its size.

Data are always copied an the copy is owned by the class instance.
*/

#include <cstddef>

class CMemoryChunk
{
public:

	// create an empty object
	CMemoryChunk();
	// create from existing data
	CMemoryChunk( const void *buf, const size_t bufSize );
	// copy constructor
	CMemoryChunk( const CMemoryChunk &mc );

	~CMemoryChunk();

	void operator=(const CMemoryChunk& mc);

	void ReleaseMemory();

	void SetData( const void *buf, const size_t bufSize );

	const void *GetAddress() const { return m_Buffer; }
	size_t GetSize() const { return m_BufferSize; }

protected:

	void Copy( const CMemoryChunk &mc );

	// data address
	unsigned char *m_Buffer;

	// data size
	size_t m_BufferSize;

};



#endif
