/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2009, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        object_description_dialog.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     07/04/2009 16:06:22
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _OBJECT_DESCRIPTION_DIALOG_H_
#define _OBJECT_DESCRIPTION_DIALOG_H_


/*!
 * Includes
 */

////@begin includes
////@end includes
#include "window_position.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CDIALOGOBJECTDESCRIPTION 10071
#define ID_STATIC_OBJECT_NAME 10072
#define ID_TEXTCTRL1 10073
#define SYMBOL_CDIALOGOBJECTDESCRIPTION_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CDIALOGOBJECTDESCRIPTION_TITLE _("Object description")
#define SYMBOL_CDIALOGOBJECTDESCRIPTION_IDNAME ID_CDIALOGOBJECTDESCRIPTION
#define SYMBOL_CDIALOGOBJECTDESCRIPTION_SIZE wxSize(400, 300)
#define SYMBOL_CDIALOGOBJECTDESCRIPTION_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CDialogObjectDescription class declaration
 */

class CDialogObjectDescription: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CDialogObjectDescription )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CDialogObjectDescription();
    CDialogObjectDescription( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGOBJECTDESCRIPTION_IDNAME, const wxString& caption = SYMBOL_CDIALOGOBJECTDESCRIPTION_TITLE, const wxPoint& pos = SYMBOL_CDIALOGOBJECTDESCRIPTION_POSITION, const wxSize& size = SYMBOL_CDIALOGOBJECTDESCRIPTION_SIZE, long style = SYMBOL_CDIALOGOBJECTDESCRIPTION_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGOBJECTDESCRIPTION_IDNAME, const wxString& caption = SYMBOL_CDIALOGOBJECTDESCRIPTION_TITLE, const wxPoint& pos = SYMBOL_CDIALOGOBJECTDESCRIPTION_POSITION, const wxSize& size = SYMBOL_CDIALOGOBJECTDESCRIPTION_SIZE, long style = SYMBOL_CDIALOGOBJECTDESCRIPTION_STYLE );

    /// Destructor
    ~CDialogObjectDescription();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

	// set the object name
	void SetObjectName( const wxString& volName );

	// sets the object description
	void SetDescription( const wxString& descr );

	// gets the description
	wxString GetDescription( void );

////@begin CDialogObjectDescription event handler declarations

////@end CDialogObjectDescription event handler declarations

////@begin CDialogObjectDescription member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CDialogObjectDescription member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CDialogObjectDescription member variables
    wxStaticText* m_ObjectNameStatic;
    wxTextCtrl* m_TextControl;
////@end CDialogObjectDescription member variables

private:

	CWindowPosition m_WindowPosition;

};

#endif
    // _OBJECT_DESCRIPTION_DIALOG_H_
