/*
	This file is part of vvvP (Virtual Volumes View Photo edition)

	Copyright (C) 2009, the vvvP Development team

	Author: Fulvio Senore

    vvvP is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    vvvP is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with vvvP; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/////////////////////////////////////////////////////////////////////////////
// Name:        resize_thumbnails_dialog.h
// Purpose:     
// Author:      
// Modified by: 
// Created:     19/10/2009 08:51:21
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _RESIZE_THUMBNAILS_DIALOG_H_
#define _RESIZE_THUMBNAILS_DIALOG_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/spinctrl.h"
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CDIALOGRESIZETHUMBNAILS 10122
#define ID_RESIZE_THUMBNAILS_SIZE 10123
#define SYMBOL_CDIALOGRESIZETHUMBNAILS_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CDIALOGRESIZETHUMBNAILS_TITLE _("Resize thumbnails")
#define SYMBOL_CDIALOGRESIZETHUMBNAILS_IDNAME ID_CDIALOGRESIZETHUMBNAILS
#define SYMBOL_CDIALOGRESIZETHUMBNAILS_SIZE wxSize(400, 300)
#define SYMBOL_CDIALOGRESIZETHUMBNAILS_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CDialogResizeThumbnails class declaration
 */

class CDialogResizeThumbnails: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CDialogResizeThumbnails )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CDialogResizeThumbnails();
    CDialogResizeThumbnails( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGRESIZETHUMBNAILS_IDNAME, const wxString& caption = SYMBOL_CDIALOGRESIZETHUMBNAILS_TITLE, const wxPoint& pos = SYMBOL_CDIALOGRESIZETHUMBNAILS_POSITION, const wxSize& size = SYMBOL_CDIALOGRESIZETHUMBNAILS_SIZE, long style = SYMBOL_CDIALOGRESIZETHUMBNAILS_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CDIALOGRESIZETHUMBNAILS_IDNAME, const wxString& caption = SYMBOL_CDIALOGRESIZETHUMBNAILS_TITLE, const wxPoint& pos = SYMBOL_CDIALOGRESIZETHUMBNAILS_POSITION, const wxSize& size = SYMBOL_CDIALOGRESIZETHUMBNAILS_SIZE, long style = SYMBOL_CDIALOGRESIZETHUMBNAILS_STYLE );

    /// Destructor
    ~CDialogResizeThumbnails();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CDialogResizeThumbnails event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for wxID_HELP
    void OnHelpClick( wxCommandEvent& event );

////@end CDialogResizeThumbnails event handler declarations

////@begin CDialogResizeThumbnails member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CDialogResizeThumbnails member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CDialogResizeThumbnails member variables
    wxSpinCtrl* m_ThumbnailsSizeCtrl;
    wxButton* m_HelpButton;
////@end CDialogResizeThumbnails member variables

	void SetThumbnailSize( int size ) { m_ThumbnailsSizeCtrl->SetValue(size); }
	int GetThumbnailsSize() { return m_ThumbnailsSizeCtrl->GetValue(); }
};

#endif
    // _RESIZE_THUMBNAILS_DIALOG_H_
