/////////////////////////////////////////////////////////////////////////////
// Name:        search_panel.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     25/05/2009 11:04:49
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "search_panel.h"
#include "sqlstrings.h"
#include "treectrl_physical.h"
#include "treectrl_virtual.h"
#include "mainframe.h"
#include "vvvpapp.h"
#include "left_right_panes_events.h"

////@begin XPM images
////@end XPM images


/*
 * CSearchPanel type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CSearchPanel, wxPanel )


/*
 * CSearchPanel event table definition
 */

BEGIN_EVENT_TABLE( CSearchPanel, wxPanel )

////@begin CSearchPanel event table entries
    EVT_SET_FOCUS( CSearchPanel::OnSetFocus )

    EVT_BUTTON( ID_BUTTON_SEARCH, CSearchPanel::OnButtonSearchClick )

////@end CSearchPanel event table entries

    EVT_CHILD_FOCUS( CSearchPanel::OnChildSetFocus )

END_EVENT_TABLE()


/*
 * CSearchPanel constructors
 */

CSearchPanel::CSearchPanel()
{
    Init();
}

CSearchPanel::CSearchPanel(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style)
{
    Init();
    Create(parent, id, pos, size, style);
}


/*
 * CSearchPanel creator
 */

bool CSearchPanel::Create(wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style)
{
////@begin CSearchPanel creation
    wxPanel::Create(parent, id, pos, size, style);
    CreateControls();
    if (GetSizer())
        GetSizer()->Fit(this);
////@end CSearchPanel creation
    return true;
}


/*
 * CSearchPanel destructor
 */

CSearchPanel::~CSearchPanel()
{
////@begin CSearchPanel destruction
////@end CSearchPanel destruction
}


/*
 * Member initialisation
 */

void CSearchPanel::Init()
{
////@begin CSearchPanel member initialisation
    m_ComboFileName = NULL;
    m_SearchFileName = NULL;
    m_SearchExtension = NULL;
    m_ComboDescription = NULL;
    m_SearchDescription = NULL;
    m_StartDate = NULL;
    m_EndDate = NULL;
    m_SearchRadioBox = NULL;
    m_SearchButton = NULL;
////@end CSearchPanel member initialisation
}


/*
 * Control creation for CSearchPanel
 */

void CSearchPanel::CreateControls()
{    
////@begin CSearchPanel content construction
    CSearchPanel* itemPanel1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemPanel1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer2->Add(itemBoxSizer3, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText4 = new wxStaticText( itemPanel1, wxID_STATIC, _("File name"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer3->Add(itemStaticText4, 3, wxALIGN_LEFT|wxALL, 5);

    wxArrayString m_ComboFileNameStrings;
    m_ComboFileNameStrings.Add(_("Contains:"));
    m_ComboFileNameStrings.Add(_("Starts With:"));
    m_ComboFileNameStrings.Add(_("Is Equal To:"));
    m_ComboFileName = new wxChoice( itemPanel1, ID_CHOICE_FILENAME, wxDefaultPosition, wxDefaultSize, m_ComboFileNameStrings, 0 );
    itemBoxSizer3->Add(m_ComboFileName, 0, wxALIGN_LEFT|wxALL, 3);

    m_SearchFileName = new wxTextCtrl( itemPanel1, ID_SEARCH_FILE_NAME, wxEmptyString, wxDefaultPosition, wxSize(120, -1), 0 );
    itemBoxSizer3->Add(m_SearchFileName, 0, wxALIGN_LEFT|wxALL, 3);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    wxBoxSizer* itemBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer3->Add(itemBoxSizer8, 0, wxALIGN_LEFT|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticText* itemStaticText9 = new wxStaticText( itemPanel1, wxID_STATIC, _("Extension:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer8->Add(itemStaticText9, 0, wxALIGN_CENTER_VERTICAL|wxALL, 3);

    m_SearchExtension = new wxTextCtrl( itemPanel1, ID_SEARCH_EXTENSION, wxEmptyString, wxDefaultPosition, wxSize(60, -1), 0 );
    itemBoxSizer8->Add(m_SearchExtension, 0, wxALIGN_CENTER_VERTICAL|wxALL, 3);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    wxStaticText* itemStaticText12 = new wxStaticText( itemPanel1, wxID_STATIC, _("Description"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer3->Add(itemStaticText12, 0, wxALIGN_LEFT|wxALL, 3);

    wxArrayString m_ComboDescriptionStrings;
    m_ComboDescriptionStrings.Add(_("Contains:"));
    m_ComboDescriptionStrings.Add(_("Starts With:"));
    m_ComboDescriptionStrings.Add(_("Is Equal To:"));
    m_ComboDescription = new wxChoice( itemPanel1, ID_CHOICE_DESCRIPTION, wxDefaultPosition, wxDefaultSize, m_ComboDescriptionStrings, 0 );
    itemBoxSizer3->Add(m_ComboDescription, 0, wxALIGN_LEFT|wxALL, 3);

    m_SearchDescription = new wxTextCtrl( itemPanel1, ID_SEARCH_DESCRIPTION, wxEmptyString, wxDefaultPosition, wxSize(120, -1), 0 );
    itemBoxSizer3->Add(m_SearchDescription, 0, wxALIGN_LEFT|wxALL, 3);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    wxStaticText* itemStaticText16 = new wxStaticText( itemPanel1, wxID_STATIC, _("Start date:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer3->Add(itemStaticText16, 0, wxALIGN_LEFT|wxALL, 3);

    m_StartDate = new fsDatePickerCtrl( itemPanel1, ID_STARTDATECTRL, wxDateTime(), wxDefaultPosition, wxDefaultSize, wxDP_DROPDOWN|wxDP_ALLOWNONE );
    itemBoxSizer3->Add(m_StartDate, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText18 = new wxStaticText( itemPanel1, wxID_STATIC, _("End date:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer3->Add(itemStaticText18, 0, wxALIGN_LEFT|wxALL, 3);

    m_EndDate = new fsDatePickerCtrl( itemPanel1, ID_ENDDATECTRL, wxDateTime(), wxDefaultPosition, wxDefaultSize, wxDP_DROPDOWN|wxDP_ALLOWNONE );
    itemBoxSizer3->Add(m_EndDate, 0, wxALIGN_LEFT|wxALL, 5);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    wxArrayString m_SearchRadioBoxStrings;
    m_SearchRadioBoxStrings.Add(_("All files"));
    m_SearchRadioBoxStrings.Add(_("Selected fixed location folder"));
    m_SearchRadioBoxStrings.Add(_("Selected removable location folder"));
    m_SearchRadioBoxStrings.Add(_("Selected virtual folder"));
    m_SearchRadioBox = new wxRadioBox( itemPanel1, ID_RADIOBOX_SEARCH, _("Search"), wxDefaultPosition, wxDefaultSize, m_SearchRadioBoxStrings, 1, wxRA_SPECIFY_COLS );
    m_SearchRadioBox->SetSelection(0);
    itemBoxSizer3->Add(m_SearchRadioBox, 0, wxALIGN_LEFT|wxALL, 3);

    itemBoxSizer3->Add(5, 5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 3);

    m_SearchButton = new wxButton( itemPanel1, ID_BUTTON_SEARCH, _("Search"), wxDefaultPosition, wxDefaultSize, 0 );
    m_SearchButton->SetDefault();
    itemBoxSizer3->Add(m_SearchButton, 0, wxALIGN_LEFT|wxALL, 3);

////@end CSearchPanel content construction

	m_StartDate->SetValueDT( wxInvalidDateTime );
	m_EndDate->SetValueDT( wxInvalidDateTime );
	m_ComboFileName->SetSelection( 0 );
	m_ComboDescription->SetSelection( 0 );
}


/*
 * Should we show tooltips?
 */

bool CSearchPanel::ShowToolTips()
{
    return true;
}

/*
 * Get bitmap resources
 */

wxBitmap CSearchPanel::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CSearchPanel bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CSearchPanel bitmap retrieval
}

/*
 * Get icon resources
 */

wxIcon CSearchPanel::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CSearchPanel icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CSearchPanel icon retrieval
}


/*
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_SEARCH
 */

void CSearchPanel::OnButtonSearchClick( wxCommandEvent& event )
{
	wxString fileName = m_SearchFileName->GetValue();
	wxString ext = m_SearchExtension->GetValue();
	wxString description = m_SearchDescription->GetValue();
	wxDateTime startDate = m_StartDate->GetValueDT();
	wxDateTime endDate = m_EndDate->GetValueDT();

	if( fileName.empty() && ext.empty() && description.empty() && !startDate.IsValid() && !endDate.IsValid() ) {
		CUtils::MsgErr( _("Please enter some search data") );
		return;
	}

	CUtils::TextSearchKind fnSearchKind;
	switch( m_ComboFileName->GetSelection() ) {
		case 0:
			fnSearchKind = CUtils::tskContains;
			break;
		case 1:
			fnSearchKind = CUtils::tskStartsWith;
			break;
		case 2:
			fnSearchKind = CUtils::tskIsEqual;
			break;
	}
	CUtils::TextSearchKind descrSearchKind;
	switch( m_ComboDescription->GetSelection() ) {
		case 0:
			descrSearchKind = CUtils::tskContains;
			break;
		case 1:
			descrSearchKind = CUtils::tskStartsWith;
			break;
		case 2:
			descrSearchKind = CUtils::tskIsEqual;
			break;
	}

	CUtils::SearchScope scope = (CUtils::SearchScope) m_SearchRadioBox->GetSelection();

	int selectedFixedFolderID = GetMainFrame()->m_TreeCtrlFixed->GetSelectedPathID();
	int selectedFixedFolderVolumeID = GetMainFrame()->m_TreeCtrlFixed->GetSelectedVolumeID();
	int selectedRemovableFolderID = GetMainFrame()->m_TreeCtrlRemovable->GetSelectedPathID();
	int selectedRemovableFolderVolumeID = GetMainFrame()->m_TreeCtrlRemovable->GetSelectedVolumeID();
	int selectedVirtualFolderID = GetMainFrame()->m_TreeCtrlVirtual->GetSelectedPathID();

	wxBusyCursor bc;
	switch( scope ) {
		case CUtils::ssAllFiles:
			{
				std::string sql = CSqlStrings::SelectForSearchPane( fileName, fnSearchKind, ext, description, 
												descrSearchKind, startDate, endDate, scope, selectedFixedFolderID, selectedRemovableFolderID, selectedVirtualFolderID );
				GetMainFrame()->ShowSearchData( sql );
			}
			break;
		case CUtils::ssSelectedFixedLocationFolder:
			GetMainFrame()->ClearSearchData();
			SearchPhysicalFolder( fileName, fnSearchKind, ext, description, descrSearchKind, startDate, endDate, selectedFixedFolderID, selectedFixedFolderVolumeID );
			GetMainFrame()->ShowSearchData( true );
			break;
		case CUtils::ssSelectedRemovableLocationFolder:
			GetMainFrame()->ClearSearchData();
			SearchPhysicalFolder( fileName, fnSearchKind, ext, description, descrSearchKind, startDate, endDate, selectedRemovableFolderID, selectedRemovableFolderVolumeID );
			GetMainFrame()->ShowSearchData( true );
			break;
		case CUtils::ssSelectedVirtualFolder:
			GetMainFrame()->ClearSearchData();
			SearchVirtualFolder( fileName, fnSearchKind, ext, description, descrSearchKind, startDate, endDate, selectedVirtualFolderID );
			GetMainFrame()->ShowSearchData( true );
			break;
		default:
			wxASSERT( false );
	}
}

void CSearchPanel::SearchPhysicalFolder( wxString fileName, CUtils::TextSearchKind fnSearchKind, 
		                       wxString extension, wxString description, CUtils::TextSearchKind descrSearchKind, 
							   wxDateTime startDate, wxDateTime endDate, int folderID, int volumeID )
{
	// first search this folder
	// always asks for a fixed location folder since removable ones work exactly the same
	std::string sql =  CSqlStrings::SelectForSearchPane( fileName, fnSearchKind, extension, description, 
		descrSearchKind, startDate, endDate, CUtils::ssSelectedFixedLocationFolder, folderID, -1, -1 );
	GetMainFrame()->StoreSearchData( sql, false, true );

	// now recursion in the subfolders
	sql = CSqlStrings::SelectPathsList( volumeID, folderID );
	Database db = wxGetApp().GetDatabase();
	FSDB_CREATE_RS_READONLY_FWDONLY( db, rs );
	rs.Open( sql );
	while( !rs.IsEOF() ) {
		int childFolderID = rs["PATH_ID"];
		SearchPhysicalFolder( fileName, fnSearchKind, extension, description, descrSearchKind, startDate, endDate, childFolderID, volumeID );
		rs.MoveNext();
	}
	rs.Close();
}

void CSearchPanel::SearchVirtualFolder( wxString fileName, CUtils::TextSearchKind fnSearchKind, 
		                       wxString extension, wxString description, CUtils::TextSearchKind descrSearchKind, 
							   wxDateTime startDate, wxDateTime endDate, int folderID )
{
	// first search this folder
	std::string sql =  CSqlStrings::SelectForSearchPane( fileName, fnSearchKind, extension, description, 
		descrSearchKind, startDate, endDate, CUtils::ssSelectedVirtualFolder, -1, -1, folderID );
	GetMainFrame()->StoreSearchData( sql, true, true );

	// now recursion in the subfolders
	sql = CSqlStrings::SelectVirtualPathsList( folderID );
	Database db = wxGetApp().GetDatabase();
	FSDB_CREATE_RS_READONLY_FWDONLY( db, rs );
	rs.Open( sql );
	while( !rs.IsEOF() ) {
		int childFolderID = rs["PATH_ID"];
		SearchVirtualFolder( fileName, fnSearchKind, extension, description, descrSearchKind, startDate, endDate, childFolderID );
		rs.MoveNext();
	}
	rs.Close();
}


void CSearchPanel::EnableScopeFixedLocation( bool enable )
{
	m_SearchRadioBox->Enable( CUtils::ssSelectedFixedLocationFolder, enable );
}

void CSearchPanel::EnableScopeRemovableLocation( bool enable )
{
	m_SearchRadioBox->Enable( CUtils::ssSelectedRemovableLocationFolder, enable );
}

void CSearchPanel::EnableScopeVirtualLocation( bool enable )
{
	m_SearchRadioBox->Enable( CUtils::ssSelectedVirtualFolder, enable );
}


/*!
 * wxEVT_SET_FOCUS event handler for ID_SEARCH_PANEL
 */

void CSearchPanel::OnSetFocus( wxFocusEvent& WXUNUSED(event) )
{
	// send the event to notify that the window received the focus
	fsLeftPaneFocusedEvent event( fsEVT_LEFT_PANE_FOCUSED, GetId() );
	event.SetEventObject( this );
	GetEventHandler()->ProcessEvent( event );
}

void CSearchPanel::OnChildSetFocus( wxChildFocusEvent& WXUNUSED(event) )
{
	// send the event to notify that the window received the focus
	fsLeftPaneFocusedEvent event( fsEVT_LEFT_PANE_FOCUSED, GetId() );
	event.SetEventObject( this );
	GetEventHandler()->ProcessEvent( event );
}

