/////////////////////////////////////////////////////////////////////////////
// Name:        cstatusbarwithgauge.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     04/12/2009 18:41:46
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
#include "wx/mstream.h"
////@end includes

#include "status_bar_with_gauge.h"

////@begin XPM images
////@end XPM images


/*!
 * CStatusBarWithGauge type definition
 */

IMPLEMENT_DYNAMIC_CLASS( CStatusBarWithGauge, wxStatusBar )


/*!
 * CStatusBarWithGauge event table definition
 */

BEGIN_EVENT_TABLE( CStatusBarWithGauge, wxStatusBar )

////@begin CStatusBarWithGauge event table entries
////@end CStatusBarWithGauge event table entries

    EVT_SIZE(CStatusBarWithGauge::OnSize)

END_EVENT_TABLE()


/*!
 * CStatusBarWithGauge constructors
 */

CStatusBarWithGauge::CStatusBarWithGauge()
{
    Init();
}

CStatusBarWithGauge::CStatusBarWithGauge(wxWindow* parent, wxWindowID id, long style)
{
    Init();
    Create(parent, id, style);
}


/*!
 * CStatusBarWithGauge creator
 */

bool CStatusBarWithGauge::Create(wxWindow* parent, wxWindowID id, long style)
{
////@begin CStatusBarWithGauge creation
    wxStatusBar::Create(parent, id, style);
    CreateControls();
////@end CStatusBarWithGauge creation
    return true;
}


/*!
 * CStatusBarWithGauge destructor
 */

CStatusBarWithGauge::~CStatusBarWithGauge()
{
////@begin CStatusBarWithGauge destruction
////@end CStatusBarWithGauge destruction
}


/*!
 * Member initialisation
 */

void CStatusBarWithGauge::Init()
{
////@begin CStatusBarWithGauge member initialisation
////@end CStatusBarWithGauge member initialisation
	m_ProgressBarCtrl = NULL;
}


/*!
 * Control creation for CStatusBarWithGauge
 */

void CStatusBarWithGauge::CreateControls()
{    
////@begin CStatusBarWithGauge content construction
////@end CStatusBarWithGauge content construction

    m_ProgressBarCtrl = new wxGauge( this, wxID_ANY, 100, wxDefaultPosition, wxDefaultSize, wxGA_HORIZONTAL );
	ProgressBarHide();
}


/*!
 * Should we show tooltips?
 */

bool CStatusBarWithGauge::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap CStatusBarWithGauge::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin CStatusBarWithGauge bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end CStatusBarWithGauge bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon CStatusBarWithGauge::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin CStatusBarWithGauge icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end CStatusBarWithGauge icon retrieval
}

void CStatusBarWithGauge::OnSize(wxSizeEvent& event)
{
	event.Skip();

	wxRect tmpRectFirst, tmpRectLast;
	
	if( GetFieldsCount() > 0 ) {
		// determine the area to be used by the gauge control
		GetFieldRect(0, tmpRectFirst);
		tmpRectFirst.x += 3;	// move a bit to the right
		tmpRectFirst.width -= 3;
		GetFieldRect(GetFieldsCount() - 1, tmpRectLast);
		wxRect tmpRect = tmpRectFirst.Union( tmpRectLast );
	
		m_ProgressBarCtrl->SetSize( tmpRect );
	}
}

void CStatusBarWithGauge::ProgressBarShow()
{
	m_ProgressBarCtrl->Show();
}

void CStatusBarWithGauge::ProgressBarHide()
{
	m_ProgressBarCtrl->Hide();
}

void CStatusBarWithGauge::ProgressBarSetRange( int range )
{
	m_ProgressBarCtrl->SetRange( range );
}

void CStatusBarWithGauge::ProgressBarSetValue( int pos )
{
	m_ProgressBarCtrl->SetValue( pos );
}

int CStatusBarWithGauge::ProgressBarGetValue()
{
	return m_ProgressBarCtrl->GetValue();
}

