/*
** Copyright (c) 1990- 1993, 1996 Open Software Foundation, Inc.
** Copyright (c) 1989 by Hewlett-Packard Company, Palo Alto, Ca. &
** Digital Equipment Corporation, Maynard, Mass.
** Copyright (c) 1998 Microsoft.
** To anyone who acknowledges that this file is provided "AS IS"
** without any express or implied warranty: permission to use, copy,
** modify, and distribute this file for any purpose is hereby
** granted without fee, provided that the above copyright notices and
** this notice appears in all source code copies, and that none of
** the names of Open Software Foundation, Inc., Hewlett-Packard
** Company, or Digital Equipment Corporation be used in advertising
** or publicity pertaining to distribution of the software without
** specific, written prior permission. Neither Open Software
** Foundation, Inc., Hewlett-Packard Company, Microsoft, nor Digital
** Equipment Corporation makes any representations about the suitability
** of this software for any purpose.
*/

/* modified for the vvvP project:
- the program will only generate UUIDs when creating a new catalog
  so generation will happen very rarely
- the program only uses V1 UUIDs so I removed the code for V3 ones
- little changes to use a different MD5 implementation
- removed the usage of files to store state information. Performance
  is not a problem here so I preferred not to have the "nodeid" and "state"
  files to complicate things
- changed file names from "sysdep" to "uuid_sysdep"
- moved the original copyright from a distinc included file to each source file

so this modified implementation is not recommended as a general purpose one */

#ifndef UUID_H
#define UUID_H

#undef uuid_t
typedef struct {
    unsigned32  time_low;
    unsigned16  time_mid;
    unsigned16  time_hi_and_version;
    unsigned8   clock_seq_hi_and_reserved;
    unsigned8   clock_seq_low;
    byte        node[6];
} uuid_t;

#ifdef __cplusplus
extern "C" 
{
#endif

/* uuid_create -- generate a UUID */
int uuid_create(uuid_t * uuid);

#ifdef __cplusplus
}  /* end extern "C" */
#endif

#endif
